import React, { useState } from 'react';
import mechData from './mech-data.json'
import MechObserver from '../MechObserver';
import Mech from '../Mech';

function MechPicker({observers} : { observers: {[key: string]: MechObserver }}) {
    const [searchText, setSearchText] = useState("");

    function notifyObservers(mech: Mech) {
        console.log("Mech clicked is ", mech);
        for (let key in observers) {
            observers[key](mech);
        }
    }

    return (
        <aside className='mech-picker'>
            <h2>Mech picker</h2>
            <label htmlFor='search-mech-input'>Search mech</label>
            <input id='search-mech-input' type='text' placeholder='Mech name' value={searchText} onChange={event => setSearchText(event.target.value)}/>
            <ul className='mech-list'>
                {mechData
                    .filter(mech => mech.name.toLowerCase().includes(searchText.toLocaleLowerCase()))
                    .map(mech => (
                        <li key={mech.id}>
                            {mech.name}
                            <button onClick={event => notifyObservers(mech)}>+</button>
                        </li>
                    ))}
            </ul>
        </aside>
    );
}

export default MechPicker;